# opentl::core::cvdata::T_MEAS_PIX Class Reference

Structure holding a single pixel-level measurement. A single measurement is related to: 1 target, 1 modality, 1 camera, 1 thread. More...

List of all members.

## Public Member Functions
std::size_t | getJacSize () const
| Get the number of Jacobian images (= state dimension).
std::size_t | getMeasSize () const
| Get the actual measurement size = size of the ROI.
bool | getUseScalarResidual () const
| Return flag for computing scalar image residual.
void | resizeAll (std::size_t width, std::size_t height, opentl::core::cvdata::Image::ColorChannels channels=opentl::core::cvdata::Image::RGB, opentl::core::cvdata::Image::BitsPerChannel bpc=opentl::core::cvdata::Image::BPC8U, std::size_t jacSize_=0)
| Set image sizes, number of channels and bits per channel (the same for all data), and Jacobian dimension.
void | setUseScalarResidual (bool val)
| Set flag for computing scalar image residual.
| T_MEAS_PIX (bool scalarResidual=true)
## Public Attributes
boost::shared_ptr < opentl::core::cvdata::Image > | E_image
| E_image = global image residual. Same number of channels of z and h, but internal type 64-bit floating point (double).
double | E_scalar
| E = scalar, global image residual between z and h.
boost::shared_ptr < opentl::core::cvdata::Image > | E_valid
| E_valid = pixel-wise validity mask for image residuals (0=missing, 1=valid). 1-channel, unsigned char.
boost::shared_ptr < opentl::core::cvdata::Image > | h
| h = expected pixel responses (e.g. target shadows). It has the same channels and internal type of z.
double | invCov
| invCov = inverse covariance of E (scalar, the same for each pixel)
std::vector< boost::shared_ptr < opentl::core::cvdata::Image > > | Jac_image
| Jac = pixel-wise Jacobian of h (set of derivative images). Each one has the same channels and type of E_image (floating point).
std::vector< double > | Jac_scalar
| Jac = Jacobian of scalar residual.
boost::shared_ptr < opentl::core::cvdata::Image > | z
| z = measured pixel responses. It may have an arbitrary number of channel and internal type.

## Detailed Description

Structure holding a single pixel-level measurement. A single measurement is related to: 1 target, 1 modality, 1 camera, 1 thread.

## Constructor & Destructor Documentation

opentl::core::cvdata::T_MEAS_PIX::T_MEAS_PIX | ( | bool | scalarResidual = `true` | ) | `[inline]`

## Member Function Documentation

std::size_t opentl::core::cvdata::T_MEAS_PIX::getJacSize | ( |  | ) | const`[inline]`

Get the number of Jacobian images (= state dimension).

std::size_t opentl::core::cvdata::T_MEAS_PIX::getMeasSize | ( |  | ) | const`[inline]`

Get the actual measurement size = size of the ROI.

bool opentl::core::cvdata::T_MEAS_PIX::getUseScalarResidual | ( |  | ) | const`[inline]`

Return flag for computing scalar image residual.

void opentl::core::cvdata::T_MEAS_PIX::resizeAll | ( | std::size_t | width,
|  | std::size_t | height,
|  | opentl::core::cvdata::Image::ColorChannels | channels = `opentl::core::cvdata::Image::RGB`,
|  | opentl::core::cvdata::Image::BitsPerChannel | bpc = `opentl::core::cvdata::Image::BPC8U`,
|  | std::size_t | jacSize_ = `0` |
| ) |  |  | `[inline]`

Set image sizes, number of channels and bits per channel (the same for all data), and Jacobian dimension.

void opentl::core::cvdata::T_MEAS_PIX::setUseScalarResidual | ( | bool | val | ) | `[inline]`

Set flag for computing scalar image residual.

## Member Data Documentation

boost::shared_ptr<opentl::core::cvdata::Image> opentl::core::cvdata::T_MEAS_PIX::E_image

E_image = global image residual. Same number of channels of z and h, but internal type 64-bit floating point (double).

double opentl::core::cvdata::T_MEAS_PIX::E_scalar

E = scalar, global image residual between z and h.

boost::shared_ptr<opentl::core::cvdata::Image> opentl::core::cvdata::T_MEAS_PIX::E_valid

E_valid = pixel-wise validity mask for image residuals (0=missing, 1=valid). 1-channel, unsigned char.

boost::shared_ptr<opentl::core::cvdata::Image> opentl::core::cvdata::T_MEAS_PIX::h

h = expected pixel responses (e.g. target shadows). It has the same channels and internal type of z.

double opentl::core::cvdata::T_MEAS_PIX::invCov

invCov = inverse covariance of E (scalar, the same for each pixel)

std::vector<boost::shared_ptr<opentl::core::cvdata::Image> > opentl::core::cvdata::T_MEAS_PIX::Jac_image

Jac = pixel-wise Jacobian of h (set of derivative images). Each one has the same channels and type of E_image (floating point).

std::vector<double> opentl::core::cvdata::T_MEAS_PIX::Jac_scalar

Jac = Jacobian of scalar residual.

boost::shared_ptr<opentl::core::cvdata::Image> opentl::core::cvdata::T_MEAS_PIX::z

z = measured pixel responses. It may have an arbitrary number of channel and internal type.